"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.AbstractCompileCangjie=void 0;const path_1=__importDefault(require("path")),hvigor_1=require("@ohos/hvigor"),ohos_logger_1=require("@ohos/hvigor-ohos-plugin/src/utils/log/ohos-logger"),file_util_1=require("@ohos/hvigor-ohos-plugin/src/utils/file-util"),child_process_1=require("child_process"),base_cangjie_task_1=require("./base-cangjie-task"),common_utils_1=require("../utils/common-utils"),cangjie_file_util_1=require("../utils/cangjie-file-util"),cangjie_task_names_1=require("./cangjie-task-names"),cangjie_dependency_1=require("../module/cangjie-dependency"),process_util_1=require("../utils/process-util"),fs_1=__importDefault(require("fs")),os_1=__importDefault(require("os")),dependency_manager_1=require("../module/dependency-manager"),cangjie_path_impl_1=require("../common/cangjie-path-impl"),cangjie_cpu_abi_enum_1=require("../enums/cangjie-cpu-abi-enum");class AbstractCompileCangjie extends base_cangjie_task_1.BaseCangjieTask{constructor(e,i){super(e,i),this.ohosLogger=ohos_logger_1.OhosLogger.getLogger(AbstractCompileCangjie.name)}initTaskDepends(){this.declareDepends(cangjie_task_names_1.CangjieTaskNames.GENERATE_CJ_RESOURCE.name)}async doTaskAction(){this.initCangjieSdk(),this.checkDependencies(),await this.executeCangjieCompile()}checkDependencies(){(0,cangjie_file_util_1.hasEtsModule)(this.moduleModel.getProjectDir())||new dependency_manager_1.DependencyManager(!1,this.moduleModel,this.projectModel).checkModelDependencyInfo()}getCjpmProcessEnv(e){if(void 0===this.sdkCangjieComponent)return{};const i=this.getGitPath(),t=(0,hvigor_1.isWindows)()?"C:\\Windows;C:\\Windows\\system32":"/bin/:/usr/bin/",s=[this.sdkCangjieComponent.runtimeLibPath,this.sdkCangjieComponent.cjcPath,this.sdkCangjieComponent.toolsBin,t,i],o=e.getBuildEnvByAbi();return(0,hvigor_1.isWindows)()?o.Path=s.join(path_1.default.delimiter):(o.PATH=s.join(path_1.default.delimiter),o.DYLD_LIBRARY_PATH=this.sdkCangjieComponent.runtimeLibPath,o.SDKROOT=this.getMacSdkRoot()),o}getCjpmBuildOptions(e){return{cwd:this.cjSource,env:e,windowsHide:!0}}async executeCangjieCompile(){if(void 0===this.sdkCangjieComponent)return;const e=path_1.default.resolve(this.sdkCangjieComponent.toolsBin,(0,hvigor_1.isWindows)()?"cjpm.exe":"cjpm");let i=os_1.default.cpus().length-2;i=i>0?i:1;for(const t of this.abiFilters){const s=new cangjie_path_impl_1.CangjiePathImpl(this.targetName,this.pathInfo,t,this.sdkCangjieComponent),o=this.getCjpmProcessEnv(s),n=this.getCjpmBuildOptions(o);this.ohosLogger._printDebugCommand("NodeEnv",o);const a=[];a.push(e),a.push("build"),a.push(`--target=${(0,cangjie_cpu_abi_enum_1.getTargetByAbi)(t)}`),a.push(`-j${i}`),a.push(`--target-dir=${path_1.default.relative(this.cjSource,s.getIntermediatesCjBuild())}`),this.targetService.isDebug()?a.push("--debug"):a.push("--release"),this.ohosLogger.debug(`Cangjie build command: ${a.join(" ")}`),await new process_util_1.ProcessUtil(this.moduleName,this.name).execute(a,n);try{this.copyResultFile(s)}catch(e){await(0,common_utils_1.delay)(500),this.copyResultFile(s)}}(0,cangjie_file_util_1.updateLog)(this.projectModel.getProjectDir())}copyResultFile(e){if(void 0===this.sdkCangjieComponent)return;const i=e.getExtendLibPath(this.moduleModel.isHarModule());file_util_1.FileUtil.checkDirWithoutDelete(i),(0,cangjie_file_util_1.clearDir)(i);const t=new cangjie_dependency_1.CangjieDependency(e.getAbi());t.doFindAllDependencies(this.cjSource,[this.sdkCangjieComponent.aarch64OhosLibPath,this.sdkCangjieComponent.macroLibPath]);const s=e.getIntermediatesCjBuildRelease();t.doCopyCompileLibs(s,"",!0,i,this.moduleModel.isHarModule()&&!fs_1.default.existsSync(path_1.default.resolve(this.pathInfo.getModuleSrcMainPath(),"ets"))),t.doCopyDependencies(i,this.moduleModel.isHarModule()&&!fs_1.default.existsSync(path_1.default.resolve(this.pathInfo.getModuleSrcMainPath(),"ets"))),this.ohosLogger.debug(`Succeeded in copying cangjie libs to ${i}.`)}getGitPath(){let e="";try{const i=["git"],t=(0,child_process_1.spawnSync)((0,hvigor_1.isWindows)()?"where":"which",i,{windowsHide:!0}),s=hvigor_1.iconv.decode(t.stdout,(0,hvigor_1.isWindows)()?"GBK":"utf-8");(0,common_utils_1.checkIsValid)(s)&&(e=path_1.default.dirname(s.split(/\r?\n|\r/g)[0]))}catch(e){}return e}getMacSdkRoot(){if(!(0,hvigor_1.isMac)())return"";let e="";try{const i=["--sdk","macosx","--show-sdk-path"],t=(0,child_process_1.spawnSync)("xcrun",i,{windowsHide:!0});e=hvigor_1.iconv.decode(t.stdout,"utf-8"),(0,common_utils_1.checkIsValid)(e)||(e="")}catch(e){}return e.trimEnd()}}exports.AbstractCompileCangjie=AbstractCompileCangjie;