"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.stringifyToml=void 0;const toml_constants_1=require("./toml-constants"),toml_enum_1=require("./toml-enum");function getTypeName(t){const n=typeof t;if("object"===n){if(Array.isArray(t))return"array";if(t instanceof Date)return"date"}return n}function isArrayOfTables(t){for(let n=0;n<t.length;n++)if("object"!==getTypeName(t[n]))return!1;return 0!==t.length}function formatString(t){return JSON.stringify(t).replace(/\x7f/g,"\\u007f")}function stringifyValue(t,n=getTypeName(t)){if("number"===n)return isNaN(t)?"nan":t===1/0?"inf":t===-1/0?"-inf":t.toString();if("bigint"===n||"boolean"===n)return t.toString();if("string"===n)return formatString(t);if("date"===n){if(isNaN(t.getTime()))throw new TypeError("cannot serialize invalid date");return t.toISOString()}return"object"===n?stringifyInlineTable(t):"array"===n?stringifyArray(t):""}function stringifyInlineTable(t){const n=Object.keys(t);if(0===n.length)return"{}";let e="{ ";for(let r=0;r<n.length;r++){const i=n[r];r&&(e+=", "),e+=toml_constants_1.KEY_REGEX.test(i)?i:formatString(i),e+=" = ",e+=stringifyValue(t[i])}return`${e} }`}function stringifyArray(t){if(0===t.length)return"[]";let n="[ ";for(let e=0;e<t.length;e++){if(e>0&&(n+=", "),null===t[e]||void 0===t[e])throw new TypeError("arrays cannot contain null or undefined values");n+=stringifyValue(t[e])}return`${n} ]`}function stringifyArrayTable(t,n,e){let r="";for(let i=0;i<t.length;i++)r+=`[[${n}]]\n`,r+=stringifyTable(t[i],n,"",e),r+="\n\n";return r}function getComment(t,n,e,r){if(!t.has(n))return{beforeComment:"",afterComment:""};const i=t.get(n);if(void 0===i||i.length<=0)return{beforeComment:"",afterComment:""};const o=[],f=[];return i.forEach((t=>{t.location===toml_enum_1.LocationEnum.BEFORE?o.push(t.comment):f.push(t.comment)})),{beforeComment:o.length>0?`${r}${o.join(`\n${r}`)}\n`:"",afterComment:f.length>0?` ${f.join("\n")}`:""}}function stringifyTable(t,n,e,r){let i="",o="";const f=Object.keys(t);for(let a=0;a<f.length;a++){const l=f[a];if(null!==t[l]&&void 0!==t[l]){const f=getTypeName(t[l]);if("symbol"===f||"function"===f)throw new TypeError(`cannot serialize values of type '${f}'`);const a=toml_constants_1.KEY_REGEX.test(l)?l:formatString(l),s=n?`${n}.${a}`:a,{beforeComment:u,afterComment:m}=getComment(r,s,toml_enum_1.LocationEnum.BEFORE,e);if("array"===f&&isArrayOfTables(t[l]))o+=u+e+stringifyArrayTable(t[l],s,r);else if("object"===f){const n=s;o+=`${u}${e}[${n}]${m}\n`,o+=stringifyTable(t[l],n,`${e}  `,r)}else i+=u+e+a,i+=" = ",i+=stringifyValue(t[l],f)+m,i+="\n"}""===n&&(o+="\n")}return`${i}${o}`}function stringifyToml(t,n){if("object"!==getTypeName(t))throw new TypeError("stringify can only be called with an object");const e=stringifyTable(t,"","",n);return null!=e?`${e.trim()}\n`:e}exports.stringifyToml=stringifyToml;